// танграм
#include "Adafruit_GFX.h"     // Библиотека обработчика графики
#include "Adafruit_ILI9341.h" // Программные драйвера для дисплеев ILI9341
#include <XPT2046_Touchscreen.h>// Библиотека для работы с сенсорным экраном
#include <SPI.h>          
#include "ris_.h"//файл хранения массивов фотокартинок
#define TFT_DC 20              // Пин подключения вывода D/C дисплея
#define TFT_CS 17              // Пин подключения вывода CS дисплея
#define CS_PIN  14
//#define TFT_RST -1            // Пин подключения вывода RESET 
//#define TFT_MISO 16           // Пин подключения вывода дисплея SDO(MISO)
//#define TFT_MOSI 19           // Пин подключения вывода дисплея SDI(MOSI)
//#define TFT_CLK 18            // Пин подключения вывода дисплея SCK

//Adafruit_ILI9341 tft = Adafruit_ILI9341(TFT_CS, TFT_DC, TFT_MOSI, TFT_CLK, TFT_RST, TFT_MISO);  // Создаем объект дисплея и сообщаем библиотеке распиновку для работы с графикой
Adafruit_ILI9341 tft = Adafruit_ILI9341(TFT_CS, TFT_DC);//
XPT2046_Touchscreen ts(CS_PIN);  // Param 2 - NULL - No interrupts


uint16_t color_=tft.color565(0,0,0);
int D=100;//
 int x, y;                         // Переменные для работы с координатами нажатий
int tangram_x[7]={50,50,50,50,50,50,50};//массивы для хранения координат центра танов и углов поворота 
int tangram_y[7]={50,50,50,50,50,50,50};// 
float tangram_a[7];//
byte f=0;//переменная указания текущей фигуры

void setup(){
  tft.begin();                      // Инициализируем начало работы с графическим дисплеем
  tft.setRotation(2);               // Переводим дисплей в альбомную ориентацию
 
  ts.begin();
  ts.setRotation(2);
 tft.fillScreen(color_);drawFoto(0,240,knopki_,240,80); //начальная отрисовка зон экрана
 }
 
void loop()
{
  /*
   for(int i=0;i<200;i++){
   figura_tn(0,i,i,0.1*i,tft.color565(0,0,0));figura_tn(0,i+1,i+1,0.1*(i+1),tft.color565(0,255,0));
   if(i==199){figura_tn(0,i+1,i+1,0.1*(i+1),tft.color565(0,0,0));}
   if(i==100){delay(2000); }
   delay(20); 
   }
  */
  if(ts.touched())         // Пока имеются данные с сенсорного модуля
  {
    TS_Point p = ts.getPoint();                      // Считываем с него данные
    y = map(p.y,220,3720,0,319);                  // Считываем и преобразуем координату нажатия X
    x =map(p.x,275,3830,0,240);                   // Считываем и преобразуем  координату нажатия Y           
    if((x!=-1) && (y!=-1))          // Если обе координаты в положительном диапазоне (т.е. если есть нажатие) 
    {
      x += 0;                      // Корректируем координату с учетом калибровочных данных
      y += -10;                       // Корректируем координату с учетом калибровочных данных
   //   
   knopki();// 
 
   //   
      }
  }
   delay(30);//
}
/////////////////////////////////////////////////////////////////
void drawFoto(uint16_t x,uint16_t y, const uint8_t *bitmap,uint16_t w,uint16_t h) {//функция вывода фотокартинки
if(x<0||x+w>240||y<0||y+h>320){return;} 
// tft.setAddrWindow(x,y,w,h);
 SPI.beginTransaction(SPISettings(40000000, MSBFIRST, SPI_MODE0));
  digitalWrite(TFT_DC, HIGH);
  digitalWrite(TFT_CS, LOW);
  tft.setAddrWindow(x,y,w,h); 
 for(int j=0; j<h; j++) {
    for(int i=0; i<2*w; i=i+2) {
    SPI.transfer(bitmap[i+1+j*2*w]);SPI.transfer(bitmap[i+j*2*w]);
    }
  }
  digitalWrite(TFT_CS, HIGH);
  SPI.endTransaction();
 ///  
}
///////////////////////////////////////////////////////////////
void figura_tn(byte figura,int Xs,int Ys,float a,uint16_t color){
 if(tangram_y[figura]<240){ 
 tangram_x[figura]=Xs;tangram_y[figura]=Ys;tangram_a[figura]=a;//
 }else{tangram_y[figura]=238;}  
 int d; 
 if(figura==0||figura==5||figura==2||figura==4){d=D;}if(figura==1||figura==6){d=0.5*D;}if(figura==3){d=0.7*D;}
 if(figura!=2&&figura!=4){ 
 int Xa=-d/6,Ya=-d/2,Xb=d/3,Yb=0,Xc=-d/6,Yc=d/2;
 int Xaa,Xbb,Xcc;//промежуточные переменные 
 Xaa=0+(Xa-0)*cos(a)-(Ya-0)*sin(a);
 Ya=0+(Xa-0)*sin(a)+(Ya-0)*cos(a);Xa=Xaa;
 Xbb=0+(Xb-0)*cos(a)-(Yb-0)*sin(a);
 Yb=0+(Xb-0)*sin(a)+(Yb-0)*cos(a);Xb=Xbb;
 Xcc=0+(Xc-0)*cos(a)-(Yc-0)*sin(a);
 Yc=0+(Xc-0)*sin(a)+(Yc-0)*cos(a);Xc=Xcc;
 tft.fillTriangle(Xs+Xa,Ys+Ya,Xs+Xb,Ys+Yb,Xs+Xc,Ys+Yc,color);
 }
 //
 
if(figura==2){
int Xa,Ya,Xb,Yb,Xc,Yc,Xe,Ye;  
 Xa=-d/4;Ya=0;Xb=0;Yb=-d/4;Xc=d/4;Yc=0,Xe=0;Ye=d/4;
 int Xaa,Xbb,Xcc,Xee;//промежуточные переменные 
 Xaa=0+(Xa-0)*cos(a)-(Ya-0)*sin(a);
 Ya=0+(Xa-0)*sin(a)+(Ya-0)*cos(a);Xa=Xaa;
 Xbb=0+(Xb-0)*cos(a)-(Yb-0)*sin(a);
 Yb=0+(Xb-0)*sin(a)+(Yb-0)*cos(a);Xb=Xbb;
 Xcc=0+(Xc-0)*cos(a)-(Yc-0)*sin(a);
 Yc=0+(Xc-0)*sin(a)+(Yc-0)*cos(a);Xc=Xcc;
 Xee=0+(Xe-0)*cos(a)-(Ye-0)*sin(a);
 Ye=0+(Xe-0)*sin(a)+(Ye-0)*cos(a);Xe=Xee;
 tft.fillTriangle(Xs+Xa,Ys+Ya,Xs+Xb,Ys+Yb,Xs+Xc,Ys+Yc,color);
 tft.fillTriangle(Xs+Xc,Ys+Yc,Xs+Xe,Ys+Ye,Xs+Xa,Ys+Ya,color);    
}
if(figura==4){
int Xa,Ya,Xb,Yb,Xc,Yc,Xe,Ye;  
Xa=-d/8;Ya=d/8;Xb=-d/8;Yb=-3*d/8;Xc=d/8;Yc=-d/8;Xe=d/8;Ye=3*d/8;
 int Xaa,Xbb,Xcc,Xee;//промежуточные переменные 
 Xaa=0+(Xa-0)*cos(a)-(Ya-0)*sin(a);
 Ya=0+(Xa-0)*sin(a)+(Ya-0)*cos(a);Xa=Xaa;
 Xbb=0+(Xb-0)*cos(a)-(Yb-0)*sin(a);
 Yb=0+(Xb-0)*sin(a)+(Yb-0)*cos(a);Xb=Xbb;
 Xcc=0+(Xc-0)*cos(a)-(Yc-0)*sin(a);
 Yc=0+(Xc-0)*sin(a)+(Yc-0)*cos(a);Xc=Xcc;
 Xee=0+(Xe-0)*cos(a)-(Ye-0)*sin(a);
 Ye=0+(Xe-0)*sin(a)+(Ye-0)*cos(a);Xe=Xee;
 tft.fillTriangle(Xs+Xa,Ys+Ya,Xs+Xb,Ys+Yb,Xs+Xc,Ys+Yc,color);
 tft.fillTriangle(Xs+Xc,Ys+Yc,Xs+Xe,Ys+Ye,Xs+Xa,Ys+Ya,color); 
   
}
}
///////////////////////////////////////////////////////////////
void knopki(){
 if(y<240){drawFoto(0,240,knopki_,240,80);}//отрисовка кнопок если их затёрли фигуры (касание любой точки рабочего поля) 
//кнопки выбора танов-фигур
if(y>260&&y<300&&x>160&&x<180){f=0;color_=tft.color565(31,188,101);figura_tn(f,tangram_x[f],tangram_y[f],tangram_a[f],color_);}
if(y>290&&x>160&&x<220){f=5;color_=tft.color565(255,199,2);figura_tn(f,tangram_x[f],tangram_y[f],tangram_a[f],color_);}
if(y>240&&y<260&&x>160&&x<180){f=1;color_=tft.color565(0,167,186);figura_tn(f,tangram_x[f],tangram_y[f],tangram_a[f],color_);}
if(y>240&&y<260&&x>220&&x<240){f=3;color_=tft.color565(141,205,49);figura_tn(f,tangram_x[f],tangram_y[f],tangram_a[f],color_);}
if(y>280&&y<290&&x>200&&x<220){f=6;color_=tft.color565(214,128,71);figura_tn(f,tangram_x[f],tangram_y[f],tangram_a[f],color_);}
if(y>250&&y<270&&x>190&&x<200){f=2;color_=tft.color565(228,58,85);figura_tn(f,tangram_x[f],tangram_y[f],tangram_a[f],color_);}
if(y>280&&y<310&&x>220&&x<240){f=4;color_=tft.color565(92,110,210);figura_tn(f,tangram_x[f],tangram_y[f],tangram_a[f],color_);}
//  
if(y>240&&y<280){//кнопки навигации
if(x<40){figura_tn(f,tangram_x[f],tangram_y[f],tangram_a[f],tft.color565(0,0,0));figura_tn(f,tangram_x[f],tangram_y[f]+2,tangram_a[f],color_);}
if(x>40&&x<80){figura_tn(f,tangram_x[f],tangram_y[f],tangram_a[f],tft.color565(0,0,0));figura_tn(f,tangram_x[f]-2,tangram_y[f],tangram_a[f],color_);}    
}
if(y>280){//кнопки навигации
if(x<40){figura_tn(f,tangram_x[f],tangram_y[f],tangram_a[f],tft.color565(0,0,0));figura_tn(f,tangram_x[f]+2,tangram_y[f],tangram_a[f],color_);}
if(x>40&&x<80){figura_tn(f,tangram_x[f],tangram_y[f],tangram_a[f],tft.color565(0,0,0));figura_tn(f,tangram_x[f],tangram_y[f]-2,tangram_a[f],color_);}    
}
if(y>240&&y<280&&x>80&&x<120){//кнопка поворота
figura_tn(f,tangram_x[f],tangram_y[f],tangram_a[f],tft.color565(0,0,0));figura_tn(f,tangram_x[f],tangram_y[f],tangram_a[f]+0.0628,color_);  
}
if(y>280&&y<320&&x>80&&x<120){//кнопка поворота
figura_tn(f,tangram_x[f],tangram_y[f],tangram_a[f],tft.color565(0,0,0));figura_tn(f,tangram_x[f],tangram_y[f],tangram_a[f]-0.0314,color_);  
}
}
///////////////////////////////////////////////////////////////
